<%-- $Id: edit_design.jsp 6312 2013-08-28 11:48:06Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%
final Item itemType = Item.ARRAYDESIGN;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	ArrayDesign design = null;
	
	boolean deniedPlatform = false;
	Platform currentPlatform = null;
	PlatformVariant currentVariant = null;
	List<Platform> defaultPlatforms = null;
	List<PlatformVariant> defaultVariants = null;
	
	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		try
		{
			defaultPlatforms = (List<Platform>)activeProject.findDefaultItems(dc, Item.PLATFORM, true);
		}
		catch (PermissionDeniedException pdex)
		{}
		try
		{
			defaultVariants = (List<PlatformVariant>)activeProject.findDefaultItems(dc, Item.PLATFORMVARIANT, true);
		}
		catch (PermissionDeniedException pdex)
		{}

	}
	if (itemId == 0)
	{
		title = "Create array design";
		cc.removeObject("item");
		int currentPlatformId = Values.getInt(cc.getRecent(Item.PLATFORM.name(), 0), 0);
		int currentVariantId = Values.getInt(cc.getRecent(Item.PLATFORMVARIANT.name(), 0), 0);
		try
		{
			if (currentPlatformId != 0) currentPlatform = Platform.getById(dc, currentPlatformId);
			if (currentVariantId != 0) currentVariant = PlatformVariant.getById(dc, currentVariantId);
		}
		catch (Throwable t)
		{}
		if (currentPlatform == null && defaultPlatforms != null && defaultPlatforms.size() > 0)
		{
			currentPlatform = defaultPlatforms.get(0);
		}
		if (currentVariant == null && defaultVariants != null && defaultVariants.size() > 0)
		{
			currentVariant = defaultVariants.get(0);
		}
	}
	else
	{
		design = ArrayDesign.getById(dc, itemId);
		design.checkPermission(Permission.WRITE);
		cc.setObject("item", design);
		title = "Edit array design -- " + HTML.encodeTags(design.getName());
		
		try
		{
			currentPlatform = design.getPlatform();
			currentVariant = design.getVariant();
		}
		catch (PermissionDeniedException ex)
		{
			deniedPlatform = true;
		}
	}

	ItemQuery<Platform> platformQuery = Platform.getQuery();
	platformQuery.include(Include.REMOVED, Include.NOT_REMOVED);
	platformQuery.order(Orders.asc(Hql.property("name")));
	platformQuery.setCacheResult(true);
	ItemResultList<Platform> platforms = platformQuery.list(dc);

	ItemQuery<PlatformVariant> variantQuery = PlatformVariant.getQuery();
	variantQuery.include(Include.REMOVED, Include.NOT_REMOVED);
	variantQuery.order(Orders.asc(Hql.property("name")));
	variantQuery.restrict(Restrictions.eq(Hql.property("platform"), Hql.entityParameter("platform", Item.PLATFORM)));
	
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), design);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>" id="edit-page">
	<base:head scripts="tabcontrol-2.js,~designs.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<style>
		.platform
		{
			font-weight: bold;
			margin-top: 2px;
		}
		</style>
	</base:head>
	<base:body>
		<h1><%=title%> <base:help tabcontrol="settings" /></h1>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="design">
		<input type="hidden" name="cmd" value="UpdateItem">

		<t:tabcontrol id="settings" 
			subclass="content dialogtabcontrol" 
			position="bottom" active="<%=tabId%>" remember="<%=tabId == null && design != null%>" 
			extensions="<%=invoker%>">
		<t:tab id="info" title="Array design" helpid="arraydesign.edit">
			<table class="fullform input100">
			<tr>
				<th>Name</th>
				<td><input class="text required auto-init" data-auto-init="<%=design == null ? "focus-select" : "focus" %>"
					type="text" name="name" 
					value="<%=HTML.encodeTags(design == null ? Values.getString(cc.getPropertyValue("name"), "New array design") : design.getName())%>" 
					maxlength="<%=ArrayDesign.MAX_NAME_LENGTH%>"></td>
				<td></td>
			</tr>
			<tr>
				<th>Platform</th>
				<td>
					<select name="platform" class="required"
						<%=deniedPlatform ? "disabled" : "" %>>
					<%
					if (deniedPlatform)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					else
					{
						for (Platform p : platforms)
						{
							if (!p.isRemoved() || p.equals(currentPlatform))
							{
								boolean selected = p.equals(currentPlatform) && currentVariant == null;
								%>
								<option class="platform"
									value="PLATFORM:<%=p.getId()%>"
									data-platform="<%=p.getId()%>"
									<%=selected ? "selected" : ""%>><%=HTML.encodeTags(p.getName()) %>
								<%
							}
							variantQuery.setEntityParameter("platform", p);
							List<PlatformVariant> variants = variantQuery.list(dc);
							PlatformVariant lastVariant = variants.size()>0 ? variants.get(variants.size()-1) : null;
							for (PlatformVariant v : variants)
							{
								if ((!v.isRemoved() || v.equals(currentVariant)) && (!p.isRemoved() || p.equals(currentPlatform)))
								{
									boolean selected = v.equals(currentVariant);
									String prefix = v == lastVariant ? " └ " : " ├ ";
									%>
									<option class="variant"
										value="VARIANT:<%=v.getId()%>"
										data-platform="<%=p.getId()%>"
										data-variant="<%=v.getId()%>"
										<%=selected ? "selected" : ""%>><%=prefix%><%=HTML.encodeTags(v.getName()) %>
									<%
								}
							}
						}
					}
					%>
					</select>
				</td>
				<td></td>
			</tr>
			<tr>
				<th>Arrays / slide</th>
				<td><input class="text required" type="text" name="numArrays" id="numArrays" style="width: 15em;"
					value="<%=design == null ? Values.getString(cc.getPropertyValue("numArrays"), "1") : design.getNumArrays()%>" 
					maxlength="10"></td>
				<td></td>
			</tr>
			<tr class="dynamic">
				<th>Description</th>
				<td>
					<textarea class="text" rows="6" name="description" id="description"
						><%=HTML.encodeTags(design == null ? cc.getPropertyValue("description") : design.getDescription())%></textarea>
				</td>
				<td style="width: 20px;">
					<base:zoom textarea="description" title="Description" />
				</td>
			</tr>
			<%
			if (sc.getActiveProjectId() != 0 && design == null && sc.getActiveProjectPermissions().contains(Permission.WRITE))
			{
				%>
				<tr>
					<th></th>
					<td>
						<input type="checkbox" id="setAsProjectDefault" name="setAsProjectDefault" value="1" 
							checked><label for="setAsProjectDefault">Set as project default</label>
					</td>
					<td></td>
				</tr>
				<%
			}
			%>
			</table>
		</t:tab>

		<t:tab id="datafiles" title="Data files" helpid="datafiles.edit">
			<jsp:include page="../../common/datafiles/select_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>

		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<jsp:include page="../../common/annotations/annotate_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" 
			helpid="annotations.edit.inherited">
			<jsp:include page="../../common/annotations/inherit_frameset.jsp">
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="ID" value="<%=ID%>" />
			</jsp:include>
		</t:tab>
		</t:tabcontrol>
		</form>

		<div class="legend">
			<base:icon image="required.png" />= required information
		</div>

		<base:buttongroup subclass="dialogbuttons">
			<base:button id="btnSave" title="Save" />
			<base:button id="close" title="Cancel" />
		</base:buttongroup>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
